#include "ModuleInfo.h"

NTSTATUS GetAllModulesInfo(PULONG * pRes)
{
    ULONG i;
    NTSTATUS status = STATUS_NOT_FOUND;

    unsigned long Base = 0;

    status = ZwQuerySystemInformation(SystemModuleInformation, &i, 0, &i); // system module info
    if (status != STATUS_INFO_LENGTH_MISMATCH)
        return status;

    *pRes = ExAllocatePool(NonPagedPool, sizeof(ULONG)*i);

    if (!*pRes)
        return STATUS_NO_MEMORY;

    status = ZwQuerySystemInformation(SystemModuleInformation, *pRes, i * sizeof(ULONG), 0);
    if (status != STATUS_SUCCESS)
    {
        ExFreePool(*pRes);
        return STATUS_UNSUCCESSFUL;
    }
    return STATUS_SUCCESS;    
}

NTSTATUS GetModuleInfo(PCHAR Mod, SYSTEM_MODULE * pInfo)
{
    ULONG i;
    NTSTATUS status = STATUS_SUCCESS;
    PULONG pBuf = 0;
    PSYSTEM_MODULE_INFORMATION pModInfo;

    status = GetAllModulesInfo(&pBuf);
    if(status != STATUS_SUCCESS)
        return status;

    pModInfo = (PSYSTEM_MODULE_INFORMATION)pBuf;
    status = STATUS_NOT_FOUND;

    for (i=0; i<*pBuf; i++)
    {
        if (!_stricmp(pModInfo->aSM[i].abName + pModInfo->aSM[i].wNameOffset, Mod))
        {
            *pInfo=pModInfo->aSM[i];
            status = STATUS_SUCCESS;
            break;
        }
    }

    ExFreePool(pBuf);
    return status;
}