#include "ProcessEnum.h"

#include <ntifs.h>

NTSTATUS ProcessEnum(ProcEnumCallback callback)
{
    PSYSTEM_PROCESS_INFORMATION pSysInfo = 0;
    PSYSTEM_PROCESS_INFORMATION pInfoEntry = 0;
    ULONG ulSysInfoSize = 0;

    // Get information about all processes
    NTSTATUS status = SystemInfoQuery(&pSysInfo, SystemProcessInformation, &ulSysInfoSize);

    if (!NT_SUCCESS(status))
        goto cleanup;

    // Enumerate the list
    pInfoEntry = pSysInfo;
    do
    {
        // Call the callback function
        status = callback(pInfoEntry);

        if (!NT_SUCCESS(status))
            goto cleanup;

        // We've been asked to stop the enumeration
        if (status == 1)
        {
            status = STATUS_SUCCESS;
            goto cleanup;
        }

        // Continue enumeration
        pInfoEntry = SpiNextEntry(pInfoEntry);
    }
    while (pInfoEntry);

cleanup:
    if (pSysInfo)
        SystemInfoFree(pSysInfo);

    return status;
}