#ifndef CODE_PATCH_H
#define CODE_PATCH_H

typedef char code_t;
typedef unsigned int size_t;

code_t* CodeAllocate(size_t nSize);
void CodeFreeBuffer(code_t* pCode, size_t nSize);

size_t CodeWriteCall(code_t* pFrom, const code_t* pTo);
size_t CodeWriteJump(code_t* pFrom, const code_t* pTo);
size_t CodeJumpSize();

size_t CodeDisplace(code_t* pDestination, code_t* pCode, size_t nSize);
size_t CodeDisplaceInstruction(code_t* pNew, code_t* pOld);

#endif