#include "MemSearch.h"

static PLSTATUS PlCompareSequence(const MASK_BUFFER* pPattern, const BUFFER* pTarget)
{
    size_t i = 0;

    if(pTarget->nSize < pPattern->nSize)
        return 0;

    for(i = 0; i < pPattern->nSize; ++i)
    {
        if ((pTarget->pStart[i] & pPattern->pMask[i]) != pPattern->pStart[i])
            return 0;
    }    
    return 1;
}


PLSTATUS PlSearchSequence(const MASK_BUFFER* pPattern, 
                          const BUFFER* pTarget, 
                          const char ** ppFirstPosition)
{
    size_t i = 0;

    if(pTarget->nSize < pPattern->nSize)
        return PL_STATUS_NOT_FOUND;

    for(i = 0; i < pTarget->nSize - pPattern->nSize; ++i)
    {
        BUFFER bufCurrentPiece = {pTarget->pStart + i, pPattern->nSize};

        if (PlCompareSequence(pPattern, &bufCurrentPiece))
        {
            *ppFirstPosition = pTarget->pStart + i;
            return PL_STATUS_SUCCESS;
        }
    }

    return PL_STATUS_NOT_FOUND;
}

PLSTATUS PlSearchSequenceBack(const MASK_BUFFER* pPattern, 
                              const BUFFER* pTarget, 
                              const char ** ppFirstPosition)
{
    size_t i;

    if(pTarget->nSize < pPattern->nSize)
        return PL_STATUS_NOT_FOUND;

    for(i = 0; i < pTarget->nSize; ++i)
    {
        BUFFER bufCurrentPiece = {pTarget->pStart - i, pPattern->nSize};

        if (PlCompareSequence(pPattern, &bufCurrentPiece))
        {
            *ppFirstPosition = pTarget->pStart - i;
            return PL_STATUS_SUCCESS;
        }
    }

    return PL_STATUS_NOT_FOUND;
}
